package com.hui.zhang.common.util.logger.slf4j;

import com.hui.zhang.common.util.logger.CentaurLogger;

import java.io.Serializable;

/**
 * Created by zuti on 2017/11/22.
 * email zuti@centaur.cn
 */
public class Slf4jLogger implements CentaurLogger, Serializable {

	private static final long serialVersionUID = 1L;

	private final org.slf4j.Logger logger;

	public Slf4jLogger(org.slf4j.Logger logger) {
		this.logger = logger;
	}

	@Override
	public void trace(String msg) {
		logger.trace(msg);
	}

	@Override
	public void trace(Throwable e) {
		logger.trace(e.getMessage(), e);
	}

	@Override
	public void trace(String msg, Throwable e) {
		logger.trace(msg, e);
	}

	@Override
	public void trace(String var1, Object... var2) {
		logger.trace(var1, var2);
	}

	@Override
	public void debug(String msg) {
		logger.debug(msg);
	}

	@Override
	public void debug(Throwable e) {
		logger.debug(e.getMessage(), e);
	}

	@Override
	public void debug(String msg, Throwable e) {
		logger.debug(msg, e);
	}

	@Override
	public void debug(String var1, Object... var2) {
		logger.debug(var1, var2);
	}

	@Override
	public void info(String msg) {
		logger.info(msg);
	}

	@Override
	public void info(Throwable e) {
		logger.info(e.getMessage(), e);
	}

	@Override
	public void info(String msg, Throwable e) {
		logger.info(msg, e);
	}

	@Override
	public void info(String var1, Object... var2) {
		logger.info(var1, var2);
	}

	@Override
	public void warn(String msg) {
		logger.warn(msg);
	}

	@Override
	public void warn(Throwable e) {
		logger.warn(e.getMessage(), e);
	}

	@Override
	public void warn(String msg, Throwable e) {
		logger.warn(msg, e);
	}

	@Override
	public void warn(String var1, Object... var2) {
		logger.warn(var1, var2);
	}

	@Override
	public void error(String msg) {
		logger.error(msg);
	}

	@Override
	public void error(Throwable e) {
		logger.error(e.getMessage(), e);
	}

	@Override
	public void error(String msg, Throwable e) {
		logger.error(msg, e);
	}

	@Override
	public void error(String var1, Object... var2) {
		logger.error(var1, var2);
	}

	@Override
	public boolean isTraceEnabled() {
		return logger.isTraceEnabled();
	}

	@Override
	public boolean isDebugEnabled() {
		return logger.isDebugEnabled();
	}

	@Override
	public boolean isInfoEnabled() {
		return logger.isInfoEnabled();
	}

	@Override
	public boolean isWarnEnabled() {
		return logger.isWarnEnabled();
	}

	@Override
	public boolean isErrorEnabled() {
		return logger.isErrorEnabled();
	}



}
